Arbor 3: FSM & BT Graph Editor 3.6.8

Public Types | Public Member Functions | Properties | List of all members
AgentController Class Reference

NavMeshAgentをラップしたAI用移動コンポーネント。
主に組み込みBehaviourのAgentを介して使用する。 More...

Inherits MonoBehaviour, and ISerializationCallbackReceiver.

## Public Types
enum | MovementType { NotChange, Normalize, DivSpeed, DivValue }
| 移動ベクトルのタイプ More...
enum | TurnType { UseX, RadianAngle }
| Turnのタイプ More...

## Public Member Functions
void | Patrol (Vector3 center, float speed, float radius)
| 指定半径内をうろつく More...
void | Patrol (float speed, float radius)
| 開始位置から指定半径内をうろつく More...
void | Follow (float speed, float stoppingDistance, Vector3 targetPosition)
| 指定した位置へ近づく More...
void | Follow (float speed, float stoppingDistance, Transform target)
| 指定したTransformの位置へ近づく More...
void | Escape (float speed, float distance, Vector3 targetPosition)
| 指定した位置から遠ざかる More...
void | Escape (float speed, float distance, Transform target)
| 指定したTransformから遠ざかる More...
void | LookAt (float angularSpeed, Vector3 targetPosition)
| 指定した位置の方向へ回転する。 More...
void | LookAt (float angularSpeed, Transform target)
| 指定したTransformの方向へ回転する。 More...
void | Resume ()
| 移動を再開する。 More...
void | Stop ()
| 停止する。 More...
bool | Warp (Vector3 newPosition)
| 指定された位置にエージェントをワープします。 More...

## Properties
NavMeshAgent | agent`[get, set]`
| 制御したいNavMeshAgent。 More...
Animator | animator`[get, set]`
| 制御したいAnimator。 More...
string | movingParameter`[get, set]`
| Agentが移動中かどうかをAnimatorへ設定するためのboolパラメータを指定する。 More...
float | movingSpeedThreshold`[get, set]`
| 移動中と判定する速度の閾値 More...
string | speedParameter`[get, set]`
| 移動速度をAnimatorへ設定するためのfloatパラメータを指定する。 More...
bool | isDivAgentSpeed`[get, set]`
| Agentに設定しているspeedで割るかどうか。 More...
float | speedDampTime`[get, set]`
| 移動速度のダンプ時間。 More...
MovementType | movementType`[get, set]`
| 移動ベクトルのタイプ。 More...
float | movementDivValue`[get, set]`
| velocityに対して割る値。(_MovementTypeがMovementType.DivValueの時のみ使用) More...
string | movementXParameter`[get, set]`
| Agentのローカル空間での移動ベクトルのX値をAnimatorへ設定ためのfloatパラメータを指定する。 More...
float | movementXDampTime`[get, set]`
| 移動方向ベクトルのX値のダンプ時間。 More...
string | movementYParameter`[get, set]`
| Agentのローカル空間での移動方向ベクトルのY値をAnimatorへ設定ためのfloatパラメータを指定する。 More...
float | movementYDampTime`[get, set]`
| 移動方向ベクトルのY値のダンプ時間。 More...
string | movementZParameter`[get, set]`
| Agentのローカル空間での移動方向ベクトルのZ値をAnimatorへ設定ためのfloatパラメータを指定する。 More...
float | movementZDampTime`[get, set]`
| 移動方向ベクトルのZ値のダンプ時間。 More...
string | turnParameter`[get, set]`
| ターン方向をAnimatorへ設定するためのfloatパラメータを指定する。 More...
TurnType | turnType`[get, set]`
| Turnのタイプ More...
float | turnDampTime`[get, set]`
| ターン方向のダンプ時間。 More...
Transform | agentTransform`[get]`
| AgentのTransform More...
bool | isDone`[get]`
| 移動完了したかどうか。 More...
bool | isMoving`[get]`
| 移動中かどうか More...

## Detailed Description

NavMeshAgentをラップしたAI用移動コンポーネント。
主に組み込みBehaviourのAgentを介して使用する。

## Member Enumeration Documentation

## ◆ MovementType

enum MovementType
| strong

移動ベクトルのタイプ

Enumerator
NotChange | NavMeshAgent.velocityの値をそのまま使用する。
Normalize | NavMeshAgent.velocityを正規化した値を使用する。
DivSpeed | NavMeshAgent.velocityをNavMeshAgent.speedで割った値を使用する。
DivValue | NavMeshAgent.velocityをMovementDivValueで割った値を使用する。

## ◆ TurnType

enum TurnType
| strong

Turnのタイプ

Enumerator
UseX | 向きベクトルのX値を使う。
RadianAngle | 向きベクトルのXZ値からラジアン角を計算する。

## Member Function Documentation

## ◆ Escape() [1/2]

void Escape | ( | float | speed,
|  | float | distance,
|  | Transform | target
| ) |  |

指定したTransformから遠ざかる

Parameters

  speed | 移動速度
  distance | 遠ざかる距離
  target | 対象

## ◆ Escape() [2/2]

void Escape | ( | float | speed,
|  | float | distance,
|  | Vector3 | targetPosition
| ) |  |

指定した位置から遠ざかる

Parameters

  speed | 移動速度
  distance | 遠ざかる距離
  targetPosition | 対象

## ◆ Follow() [1/2]

void Follow | ( | float | speed,
|  | float | stoppingDistance,
|  | Transform | target
| ) |  |

指定したTransformの位置へ近づく

Parameters

  speed | 移動速度
  stoppingDistance | 停止距離
  target | 目標地点

## ◆ Follow() [2/2]

void Follow | ( | float | speed,
|  | float | stoppingDistance,
|  | Vector3 | targetPosition
| ) |  |

指定した位置へ近づく

Parameters

  speed | 移動速度
  stoppingDistance | 停止距離
  targetPosition | 目標地点

## ◆ LookAt() [1/2]

void LookAt | ( | float | angularSpeed,
|  | Transform | target
| ) |  |

指定したTransformの方向へ回転する。

Parameters

  angularSpeed | 角速度
  target | 対象

## ◆ LookAt() [2/2]

void LookAt | ( | float | angularSpeed,
|  | Vector3 | targetPosition
| ) |  |

指定した位置の方向へ回転する。

Parameters

  angularSpeed | 角速度
  targetPosition | 対象

## ◆ Patrol() [1/2]

void Patrol | ( | float | speed,
|  | float | radius
| ) |  |

開始位置から指定半径内をうろつく

Parameters

  speed | 移動速度
  radius | 開始位置からの半径

## ◆ Patrol() [2/2]

void Patrol | ( | Vector3 | center,
|  | float | speed,
|  | float | radius
| ) |  |

指定半径内をうろつく

Parameters

  center | 中心
  speed | 移動速度
  radius | 開始位置からの半径

## ◆ Resume()

void Resume | ( |  | ) |

移動を再開する。

## ◆ Stop()

void Stop | ( |  | ) |

停止する。

## ◆ Warp()

bool Warp | ( | Vector3 | newPosition | ) |

指定された位置にエージェントをワープします。

Parameters

  newPosition | エージェントをワープさせる位置

Returns
  経路の割り当てに成功した場合 true

## Property Documentation

## ◆ agent

NavMeshAgent agent
| get set

制御したいNavMeshAgent。

## ◆ agentTransform

Transform agentTransform
| get

AgentのTransform

## ◆ animator

Animator animator
| get set

制御したいAnimator。

## ◆ isDivAgentSpeed

bool isDivAgentSpeed
| get set

Agentに設定しているspeedで割るかどうか。

## ◆ isDone

bool isDone
| get

移動完了したかどうか。

## ◆ isMoving

bool isMoving
| get

移動中かどうか

## ◆ movementDivValue

float movementDivValue
| get set

velocityに対して割る値。(_MovementTypeがMovementType.DivValueの時のみ使用)

0を指定した場合は無効。

## ◆ movementType

MovementType movementType
| get set

移動ベクトルのタイプ。

## ◆ movementXDampTime

float movementXDampTime
| get set

移動方向ベクトルのX値のダンプ時間。

## ◆ movementXParameter

string movementXParameter
| get set

Agentのローカル空間での移動ベクトルのX値をAnimatorへ設定ためのfloatパラメータを指定する。

## ◆ movementYDampTime

float movementYDampTime
| get set

移動方向ベクトルのY値のダンプ時間。

## ◆ movementYParameter

string movementYParameter
| get set

Agentのローカル空間での移動方向ベクトルのY値をAnimatorへ設定ためのfloatパラメータを指定する。

## ◆ movementZDampTime

float movementZDampTime
| get set

移動方向ベクトルのZ値のダンプ時間。

## ◆ movementZParameter

string movementZParameter
| get set

Agentのローカル空間での移動方向ベクトルのZ値をAnimatorへ設定ためのfloatパラメータを指定する。

## ◆ movingParameter

string movingParameter
| get set

Agentが移動中かどうかをAnimatorへ設定するためのboolパラメータを指定する。

## ◆ movingSpeedThreshold

float movingSpeedThreshold
| get set

移動中と判定する速度の閾値

## ◆ speedDampTime

float speedDampTime
| get set

移動速度のダンプ時間。

## ◆ speedParameter

string speedParameter
| get set

移動速度をAnimatorへ設定するためのfloatパラメータを指定する。

## ◆ turnDampTime

float turnDampTime
| get set

ターン方向のダンプ時間。

## ◆ turnParameter

string turnParameter
| get set

ターン方向をAnimatorへ設定するためのfloatパラメータを指定する。

## ◆ turnType

TurnType turnType
| get set

Turnのタイプ